$
$   TOPPERS/ASP Kernel
$       Toyohashi Open Platform for Embedded Real-Time Systems/
$       Advanced Standard Profile Kernel
$ 
$   Copyright (C) 2007 by TAKAGI Nobuhisa
$   Copyright (C) 2007-2014 by Embedded and Real-Time Systems Laboratory
$               Graduate School of Information Science, Nagoya Univ., JAPAN
$ 
$   上記著作権者は，以下の(1)〜(4)の条件を満たす場合に限り，本ソフトウェ
$   ア（本ソフトウェアを改変したものを含む．以下同じ）を使用・複製・改
$   変・再配布（以下，利用と呼ぶ）することを無償で許諾する．
$   (1) 本ソフトウェアをソースコードの形で利用する場合には，上記の著作
$       権表示，この利用条件および下記の無保証規定が，そのままの形でソー
$       スコード中に含まれていること．
$   (2) 本ソフトウェアを，ライブラリ形式など，他のソフトウェア開発に使
$       用できる形で再配布する場合には，再配布に伴うドキュメント（利用
$       者マニュアルなど）に，上記の著作権表示，この利用条件および下記
$       の無保証規定を掲載すること．
$   (3) 本ソフトウェアを，機器に組み込むなど，他のソフトウェア開発に使
$       用できない形で再配布する場合には，次のいずれかの条件を満たすこ
$       と．
$     (a) 再配布に伴うドキュメント（利用者マニュアルなど）に，上記の著
$         作権表示，この利用条件および下記の無保証規定を掲載すること．
$     (b) 再配布の形態を，別に定める方法によって，TOPPERSプロジェクトに
$         報告すること．
$   (4) 本ソフトウェアの利用により直接的または間接的に生じるいかなる損
$       害からも，上記著作権者およびTOPPERSプロジェクトを免責すること．
$       また，本ソフトウェアのユーザまたはエンドユーザからのいかなる理
$       由に基づく請求からも，上記著作権者およびTOPPERSプロジェクトを
$       免責すること．
$ 
$   本ソフトウェアは，無保証で提供されているものである．上記著作権者お
$   よびTOPPERSプロジェクトは，本ソフトウェアに関して，特定の使用目的
$   に対する適合性も含めて，いかなる保証も行わない．また，本ソフトウェ
$   アの利用により直接的または間接的に生じたいかなる損害に関しても，そ
$   の責任を負わない．
$ 
$   $Id: mutex.tf 480 2016-01-03 07:37:12Z ertl-hiro $
$ 

$
$		ミューテックス機能のテンプレートファイル
$

$
$  kernel_cfg.hの生成
$
$FILE "kernel_cfg.h.new"$

#define TNUM_MTXID	$LENGTH(MTX.ID_LIST)$$NL$
$FOREACH id MTX.ID_LIST$
	#define $id$	$+id$$NL$
$END$

$
$  kernel_cfg.cの生成
$
$FILE "kernel_cfg.c"$

/*$NL$
$SPC$*  Mutex Functions$NL$
$SPC$*/$NL$
$NL$

$
$  ミューテックスのID番号を保持する変数
$
$IF USE_EXTERNAL_ID$
	$FOREACH id MTX.ID_LIST$
		const ID $id$_id = $+id$;$NL$
	$END$
$END$

$
$  ミューテックスID番号の最大値
$
const ID _kernel_tmax_mtxid = (TMIN_MTXID + TNUM_MTXID - 1);$NL$
$NL$

$
$  ミューテックス初期化ブロック
$
$IF LENGTH(MTX.ID_LIST)$
	$FOREACH mtxid MTX.ID_LIST$
$		// mtxatrが無効の場合（E_RSATR）［NGKI2025］
$		//（TA_NULL，TA_TPRI，TA_CEILINGのいずれでもない場合）
		$IF !(MTX.MTXATR[mtxid] == 0 || MTX.MTXATR[mtxid] == TA_TPRI
										|| MTX.MTXATR[mtxid] == TA_CEILING)$
			$ERROR MTX.TEXT_LINE[mtxid]$E_RSATR:$SPC$
				$FORMAT(_("illegal %1% `%2%\' of `%3%\' in %4%"),
							"mtxatr", MTX.MTXATR[mtxid], mtxid, "CRE_MTX")$
			$END$
		$END$

$		// ceilpriが未指定の場合は0と見なす
		$IF !LENGTH(MTX.CEILPRI[mtxid])$
			$MTX.CEILPRI[mtxid] = 0$
		$END$

$		// 優先度上限ミューテックスで，(TMIN_TPRI <= ceilpri && ceilpri <=
$		// TMAX_TPRI)でない場合（E_PAR）［NGKI2037］
		$IF MTX.MTXATR[mtxid] == TA_CEILING && (MTX.CEILPRI[mtxid] < TMIN_TPRI
											|| TMAX_TPRI < MTX.CEILPRI[mtxid])$
			$ERROR MTX.TEXT_LINE[mtxid]$E_PAR:$SPC$
				$FORMAT(_("illegal %1% `%2%\' of `%3%\' in %4%"),
							"ceilpri", MTX.CEILPRI[mtxid], mtxid, "CRE_MTX")$
			$END$
		$END$

$		// 優先度上限ミューテックスで，ceilpriがサブ優先度を使用すると設
$		// 定されている場合（E_ILUSE）［NGKI3682］
		$IF MTX.MTXATR[mtxid] == TA_CEILING
							&& LENGTH(FIND(spr_tskpri, MTX.CEILPRI[mtxid]))$
			$ERROR MTX.TEXT_LINE[mtxid]$E_ILUSE:$SPC$
				$FORMAT(_("illegal %1% `%2%\' of `%3%\' in %4%"),
							"ceilpri", MTX.CEILPRI[mtxid], mtxid, "CRE_MTX")$
			$END$
		$END$
	$END$

$	// ミューテックス初期化ブロック
	const MTXINIB _kernel_mtxinib_table[TNUM_MTXID] = {$NL$
	$JOINEACH mtxid MTX.ID_LIST ",\n"$
		$TAB${$SPC$
			($MTX.MTXATR[mtxid]$),$SPC$
			INT_PRIORITY($MTX.CEILPRI[mtxid]$)$SPC$
		}$END$$NL$
	};$NL$
$ELSE$
	TOPPERS_EMPTY_LABEL(const MTXINIB, _kernel_mtxinib_table);$NL$
$END$$NL$

$
$  ミューテックス管理ブロックとミューテックス機能初期化関数
$
$IF LENGTH(MTX.ID_LIST)$
	MTXCB _kernel_mtxcb_table[TNUM_MTXID];$NL$
	$initfuncs = APPEND(initfuncs, "_kernel_initialize_mutex();")$
$ELSE$
	TOPPERS_EMPTY_LABEL(MTXCB, _kernel_mtxcb_table);$NL$
$END$$NL$
