$
$   TOPPERS/ASP Kernel
$       Toyohashi Open Platform for Embedded Real-Time Systems/
$       Advanced Standard Profile Kernel
$ 
$   Copyright (C) 2007 by TAKAGI Nobuhisa
$   Copyright (C) 2007-2015 by Embedded and Real-Time Systems Laboratory
$               Graduate School of Information Science, Nagoya Univ., JAPAN
$ 
$   上記著作権者は，以下の(1)〜(4)の条件を満たす場合に限り，本ソフトウェ
$   ア（本ソフトウェアを改変したものを含む．以下同じ）を使用・複製・改
$   変・再配布（以下，利用と呼ぶ）することを無償で許諾する．
$   (1) 本ソフトウェアをソースコードの形で利用する場合には，上記の著作
$       権表示，この利用条件および下記の無保証規定が，そのままの形でソー
$       スコード中に含まれていること．
$   (2) 本ソフトウェアを，ライブラリ形式など，他のソフトウェア開発に使
$       用できる形で再配布する場合には，再配布に伴うドキュメント（利用
$       者マニュアルなど）に，上記の著作権表示，この利用条件および下記
$       の無保証規定を掲載すること．
$   (3) 本ソフトウェアを，機器に組み込むなど，他のソフトウェア開発に使
$       用できない形で再配布する場合には，次のいずれかの条件を満たすこ
$       と．
$     (a) 再配布に伴うドキュメント（利用者マニュアルなど）に，上記の著
$         作権表示，この利用条件および下記の無保証規定を掲載すること．
$     (b) 再配布の形態を，別に定める方法によって，TOPPERSプロジェクトに
$         報告すること．
$   (4) 本ソフトウェアの利用により直接的または間接的に生じるいかなる損
$       害からも，上記著作権者およびTOPPERSプロジェクトを免責すること．
$       また，本ソフトウェアのユーザまたはエンドユーザからのいかなる理
$       由に基づく請求からも，上記著作権者およびTOPPERSプロジェクトを
$       免責すること．
$ 
$   本ソフトウェアは，無保証で提供されているものである．上記著作権者お
$   よびTOPPERSプロジェクトは，本ソフトウェアに関して，特定の使用目的
$   に対する適合性も含めて，いかなる保証も行わない．また，本ソフトウェ
$   アの利用により直接的または間接的に生じたいかなる損害に関しても，そ
$   の責任を負わない．
$ 
$   $Id: exception.tf 462 2015-08-29 13:07:45Z ertl-hiro $
$ 

$
$		CPU例外管理機能のテンプレートファイル
$

$
$  kernel_cfg.cの生成
$
$FILE "kernel_cfg.c"$

/*$NL$
$SPC$*  CPU Exception Management Functions$NL$
$SPC$*/$NL$
$NL$

$
$  CPU例外ハンドラに関するエラーチェック
$
$ EXCNO_LIST：処理済みのCPU例外ハンドラ番号のリスト（ここでのみ使用）
$
$FOREACH excno EXC.ORDER_LIST$
$	// excnoがCPU例外ハンドラ番号として正しくない場合（E_PAR）［NGKI3134］
	$IF !LENGTH(FIND(EXCNO_VALID, EXC.EXCNO[excno]))$
		$ERROR EXC.TEXT_LINE[excno]$E_PAR:$SPC$
			$FORMAT(_("illegal %1% `%2%\' in %3%"),
						"excno", EXC.EXCNO[excno], "DEF_EXC")$
		$END$
	$END$

$	// excnoがDEF_EXCによって設定済みの場合（E_OBJ）［NGKI3141］
	$IF LENGTH(FIND(EXCNO_LIST, EXC.EXCNO[excno]))$
		$ERROR EXC.TEXT_LINE[excno]$E_OBJ:$SPC$
			$FORMAT(_("%1% `%2%\' in %3% is duplicated"),
						"excno", EXC.EXCNO[excno], "DEF_EXC")$
		$END$
	$END$

$	// excatrが無効の場合（E_RSATR）［NGKI3131］
$	//（TARGET_EXCATR以外のビットがセットされている場合）
	$IF (EXC.EXCATR[excno] & ~TARGET_EXCATR) != 0$
		$ERROR EXC.TEXT_LINE[excno]$E_RSATR:$SPC$
			$FORMAT(_("illegal %1% `%2%\' of %3% `%4%\' in %5%"),
						"excatr", EXC.EXCATR[excno], "excno",
						EXC.EXCNO[excno], "DEF_EXC")$
		$END$
	$END$

	$EXCNO_LIST = APPEND(EXCNO_LIST, EXC.EXCNO[excno])$
$END$

$
$  CPU例外ハンドラのための標準的な初期化情報の生成
$
$IF !OMIT_INITIALIZE_EXCEPTION$

$
$  定義するCPU例外ハンドラの数
$
#define TNUM_DEF_EXCNO	$LENGTH(EXC.ORDER_LIST)$$NL$
const uint_t _kernel_tnum_def_excno = TNUM_DEF_EXCNO;$NL$
$NL$

$
$  CPU例外ハンドラのエントリ
$
$FOREACH excno EXC.ORDER_LIST$
	EXCHDR_ENTRY($EXC.EXCNO[excno]$, $+EXC.EXCNO[excno]$,$SPC$
										$EXC.EXCHDR[excno]$)$NL$
$END$$NL$

$
$  CPU例外ハンドラ初期化ブロック
$
$IF LENGTH(EXC.ORDER_LIST)$
	const EXCINIB _kernel_excinib_table[TNUM_DEF_EXCNO] = {$NL$
	$JOINEACH excno EXC.ORDER_LIST ",\n"$
		$TAB${$SPC$
			($EXC.EXCNO[excno]$),$SPC$
			($EXC.EXCATR[excno]$),$SPC$
			(FP)(EXC_ENTRY($EXC.EXCNO[excno]$, $EXC.EXCHDR[excno]$))$SPC$
		}$END$$NL$
	};$NL$
$ELSE$
	TOPPERS_EMPTY_LABEL(const EXCINIB, _kernel_excinib_table);$NL$
$END$$NL$
$END$

$
$  CPU例外ハンドラ管理機能初期化関数
$
$initfuncs = APPEND(initfuncs, "_kernel_initialize_exception();")$
